Index: trunk/doc/manual/en_US/user_AdvancedTopics.xml
===================================================================
--- trunk/doc/manual/en_US/user_AdvancedTopics.xml	(revision 47003)
+++ trunk/doc/manual/en_US/user_AdvancedTopics.xml	(revision 47004)
@@ -2844,5 +2844,5 @@
     is no option to use password hashes. This leaves no other choice than
     having a clear-text password in the VM configuration, which can be set with
-    the following command:<screen>VBoxManage modifyvm VMNAME --vrdeproperty VNCPassword=secret</screen></para>
+    the following command:<screen>VBoxManage modifyvm "VM name" --vrdeproperty VNCPassword=secret</screen></para>
 
     <para>The user is responsible for keeping this password secret, and it
@@ -2956,5 +2956,5 @@
     <para>The expert storage management mode can be enabled per VM executing:</para>
 
-    <screen>VBoxManage setextradata vmname "VBoxInternal2/SilentReconfigureWhilePaused" 1
+    <screen>VBoxManage setextradata "VM name" "VBoxInternal2/SilentReconfigureWhilePaused" 1
 </screen>
 
Index: trunk/doc/manual/en_US/user_VBoxManage.xml
===================================================================
--- trunk/doc/manual/en_US/user_VBoxManage.xml	(revision 47003)
+++ trunk/doc/manual/en_US/user_VBoxManage.xml	(revision 47004)
@@ -1388,5 +1388,5 @@
     <glosslist>
       <glossentry>
-        <glossterm>gui</glossterm>
+        <glossterm><computeroutput>gui</computeroutput></glossterm>
 
         <glossdef>
@@ -1396,5 +1396,5 @@
 
       <glossentry>
-        <glossterm>headless</glossterm>
+        <glossterm><computeroutput>headless</computeroutput></glossterm>
 
         <glossdef>
@@ -1404,5 +1404,5 @@
 
       <glossentry>
-        <glossterm>sdl</glossterm>
+        <glossterm><computeroutput>sdl</computeroutput></glossterm>
 
         <glossdef>
@@ -1482,5 +1482,5 @@
 
         <listitem>
-          <para><computeroutput>VBoxManage controlvm &lt;vm&gt; teleport
+          <para><computeroutput>VBoxManage controlvm "VM name" teleport
           --hostname &lt;name&gt; --port &lt;port&gt; [--passwordfile
           &lt;file&gt; | --password &lt;password&gt;]</computeroutput> makes
@@ -1708,5 +1708,5 @@
     <para>The common parameters are:<glosslist>
         <glossentry>
-          <glossterm>uuid|vmname</glossterm>
+          <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
 
           <glossdef>
@@ -1716,5 +1716,5 @@
 
         <glossentry>
-          <glossterm>storagectl</glossterm>
+          <glossterm><computeroutput>--storagectl</computeroutput></glossterm>
 
           <glossdef>
@@ -1727,5 +1727,5 @@
 
         <glossentry>
-          <glossterm>port</glossterm>
+          <glossterm><computeroutput>--port</computeroutput></glossterm>
 
           <glossdef>
@@ -1737,5 +1737,5 @@
 
         <glossentry>
-          <glossterm>device</glossterm>
+          <glossterm><computeroutput>--device</computeroutput></glossterm>
 
           <glossdef>
@@ -1747,5 +1747,5 @@
 
         <glossentry>
-          <glossterm>type</glossterm>
+          <glossterm><computeroutput>--type</computeroutput></glossterm>
 
           <glossdef>
@@ -1759,5 +1759,5 @@
 
         <glossentry>
-          <glossterm>medium</glossterm>
+          <glossterm><computeroutput>--medium</computeroutput></glossterm>
 
           <glossdef>
@@ -1817,5 +1817,5 @@
 
         <glossentry>
-          <glossterm>mtype</glossterm>
+          <glossterm><computeroutput>--mtype</computeroutput></glossterm>
 
           <glossdef>
@@ -1827,5 +1827,5 @@
 
         <glossentry>
-          <glossterm>comment</glossterm>
+          <glossterm><computeroutput>--comment</computeroutput></glossterm>
 
           <glossdef>
@@ -1838,5 +1838,5 @@
 
         <glossentry>
-          <glossterm>setuuid, setparentuuid</glossterm>
+          <glossterm><computeroutput>--setuuid, --setparentuuid</computeroutput></glossterm>
 
           <glossdef>
@@ -1853,5 +1853,5 @@
 
         <glossentry>
-          <glossterm>passthrough</glossterm>
+          <glossterm><computeroutput>--passthrough</computeroutput></glossterm>
 
           <glossdef>
@@ -1863,5 +1863,5 @@
 
         <glossentry>
-          <glossterm>tempeject</glossterm>
+          <glossterm><computeroutput>--tempeject</computeroutput></glossterm>
 
           <glossdef>
@@ -1874,5 +1874,5 @@
 
         <glossentry>
-          <glossterm>nonrotational</glossterm>
+          <glossterm><computeroutput>--nonrotational</computeroutput></glossterm>
 
           <glossdef>
@@ -1885,5 +1885,5 @@
 
         <glossentry>
-          <glossterm>bandwidthgroup</glossterm>
+          <glossterm><computeroutput>--bandwidthgroup</computeroutput></glossterm>
 
           <glossdef>
@@ -1894,5 +1894,5 @@
 
         <glossentry>
-          <glossterm>forceunmount</glossterm>
+          <glossterm><computeroutput>--forceunmount</computeroutput></glossterm>
 
           <glossdef>
@@ -1910,5 +1910,5 @@
     be used:<glosslist>
         <glossentry>
-          <glossterm>server</glossterm>
+          <glossterm><computeroutput>--server</computeroutput></glossterm>
 
           <glossdef>
@@ -1919,5 +1919,5 @@
 
         <glossentry>
-          <glossterm>target</glossterm>
+          <glossterm><computeroutput>--target</computeroutput></glossterm>
 
           <glossdef>
@@ -1928,5 +1928,5 @@
 
         <glossentry>
-          <glossterm>tport</glossterm>
+          <glossterm><computeroutput>--tport</computeroutput></glossterm>
 
           <glossdef>
@@ -1937,5 +1937,5 @@
 
         <glossentry>
-          <glossterm>lun</glossterm>
+          <glossterm><computeroutput>--lun</computeroutput></glossterm>
 
           <glossdef>
@@ -1946,5 +1946,5 @@
 
         <glossentry>
-          <glossterm>username, password</glossterm>
+          <glossterm><computeroutput>--username, --password</computeroutput></glossterm>
 
           <glossdef>
@@ -1961,5 +1961,5 @@
 
         <glossentry>
-          <glossterm>intnet</glossterm>
+          <glossterm><computeroutput>--intnet</computeroutput></glossterm>
 
           <glossdef>
@@ -1994,5 +1994,5 @@
     <para>where the parameters mean: <glosslist>
         <glossentry>
-          <glossterm>uuid|vmname</glossterm>
+          <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
 
           <glossdef>
@@ -2002,5 +2002,5 @@
 
         <glossentry>
-          <glossterm>name</glossterm>
+          <glossterm><computeroutput>--name</computeroutput></glossterm>
 
           <glossdef>
@@ -2010,5 +2010,5 @@
 
         <glossentry>
-          <glossterm>add</glossterm>
+          <glossterm><computeroutput>--add</computeroutput></glossterm>
 
           <glossdef>
@@ -2019,5 +2019,5 @@
 
         <glossentry>
-          <glossterm>controller</glossterm>
+          <glossterm><computeroutput>--controller</computeroutput></glossterm>
 
           <glossdef>
@@ -2028,5 +2028,5 @@
 
         <glossentry>
-          <glossterm>sataportcount</glossterm>
+          <glossterm><computeroutput>--sataportcount</computeroutput></glossterm>
 
           <glossdef>
@@ -2037,5 +2037,5 @@
 
         <glossentry>
-          <glossterm>hostiocache</glossterm>
+          <glossterm><computeroutput>--hostiocache</computeroutput></glossterm>
 
           <glossdef>
@@ -2047,5 +2047,5 @@
 
         <glossentry>
-          <glossterm>bootable</glossterm>
+          <glossterm><computeroutput>--bootable</computeroutput></glossterm>
 
           <glossdef>
@@ -2055,5 +2055,5 @@
 
         <glossentry>
-          <glossterm>remove</glossterm>
+          <glossterm><computeroutput>--remove</computeroutput></glossterm>
 
           <glossdef>
@@ -2095,5 +2095,5 @@
     <para>The parameters mean:<glosslist>
         <glossentry>
-          <glossterm>uuid|vmname</glossterm>
+          <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
 
           <glossdef>
@@ -2103,5 +2103,5 @@
 
         <glossentry>
-          <glossterm>name</glossterm>
+          <glossterm><computeroutput>--name</computeroutput></glossterm>
 
           <glossdef>
@@ -2111,5 +2111,5 @@
 
         <glossentry>
-          <glossterm>type</glossterm>
+          <glossterm><computeroutput>--type</computeroutput></glossterm>
 
           <glossdef>
@@ -2124,5 +2124,5 @@
 
         <glossentry>
-          <glossterm>limit</glossterm>
+          <glossterm><computeroutput>--limit</computeroutput></glossterm>
 
           <glossdef>
@@ -2176,5 +2176,5 @@
     <para>where the parameters mean:<glosslist>
         <glossentry>
-          <glossterm>filename</glossterm>
+          <glossterm><computeroutput>--filename</computeroutput></glossterm>
 
           <glossdef>
@@ -2184,5 +2184,5 @@
 
         <glossentry>
-          <glossterm>size</glossterm>
+          <glossterm><computeroutput>--size</computeroutput></glossterm>
 
           <glossdef>
@@ -2193,5 +2193,5 @@
 
         <glossentry>
-          <glossterm>format</glossterm>
+          <glossterm><computeroutput>--format</computeroutput></glossterm>
 
           <glossdef>
@@ -2202,5 +2202,5 @@
 
         <glossentry>
-          <glossterm>variant</glossterm>
+          <glossterm><computeroutput>--variant</computeroutput></glossterm>
 
           <glossdef>
@@ -2223,5 +2223,5 @@
     <para>With the <computeroutput>modifyhd</computeroutput> command, you can
     change the characteristics of a disk image after it has been
-    created:<screen>VBoxManage modifyhd         &lt;uuid&gt;|&lt;filename&gt;
+    created:<screen>VBoxManage modifyhd         &lt;uuid|filename&gt;
                             [--type normal|writethrough|immutable|shareable|
                                     readonly|multiattach]
@@ -2317,5 +2317,5 @@
     linkend="cloningvdis" />. The syntax is as follows:</para>
 
-    <screen>VBoxManage clonehd         &lt;uuid&gt;|&lt;filename&gt; &lt;outputfile&gt;
+    <screen>VBoxManage clonehd         &lt;uuid|inutfile&gt; &lt;uuid|outputfile&gt;
                            [--format VDI|VMDK|VHD|RAW|&lt;other&gt;]
                            [--variant Standard,Fixed,Split2G,Stream,ESX]
@@ -2330,5 +2330,5 @@
     <para>The following options are available:<glosslist>
         <glossentry>
-          <glossterm>format</glossterm>
+          <glossterm><computeroutput>--format</computeroutput></glossterm>
 
           <glossdef>
@@ -2339,5 +2339,5 @@
 
         <glossentry>
-          <glossterm>variant</glossterm>
+          <glossterm><computeroutput>--variant</computeroutput></glossterm>
 
           <glossdef>
@@ -2350,5 +2350,5 @@
 
         <glossentry>
-          <glossterm>existing</glossterm>
+          <glossterm><computeroutput>--existing</computeroutput></glossterm>
 
           <glossdef>
@@ -2385,5 +2385,5 @@
     <para>where the parameters mean:<glosslist>
         <glossentry>
-          <glossterm>bytes</glossterm>
+          <glossterm><computeroutput>--bytes</computeroutput></glossterm>
 
           <glossdef>
@@ -2394,5 +2394,5 @@
 
         <glossentry>
-          <glossterm>format</glossterm>
+          <glossterm><computeroutput>--format</computeroutput></glossterm>
 
           <glossdef>
@@ -2403,5 +2403,5 @@
 
         <glossentry>
-          <glossterm>variant</glossterm>
+          <glossterm><computeroutput>--variant</computeroutput></glossterm>
 
           <glossdef>
@@ -2414,5 +2414,5 @@
 
         <glossentry>
-          <glossterm>uuid</glossterm>
+          <glossterm><computeroutput>--uuid</computeroutput></glossterm>
 
           <glossdef>
@@ -2472,5 +2472,5 @@
     following properties are available:<glosslist>
         <glossentry>
-          <glossterm>machinefolder</glossterm>
+          <glossterm><computeroutput>machinefolder</computeroutput></glossterm>
 
           <glossdef>
@@ -2482,5 +2482,5 @@
 
         <glossentry>
-          <glossterm>vrdeauthlibrary</glossterm>
+          <glossterm><computeroutput>vrdeauthlibrary</computeroutput></glossterm>
 
           <glossdef>
@@ -2492,5 +2492,5 @@
 
         <glossentry>
-          <glossterm>websrvauthlibrary</glossterm>
+          <glossterm><computeroutput>websrvauthlibrary</computeroutput></glossterm>
 
           <glossdef>
@@ -2503,5 +2503,5 @@
 
         <glossentry>
-          <glossterm>vrdeextpack</glossterm>
+          <glossterm><computeroutput>vrdeextpack</computeroutput></glossterm>
 
           <glossdef>
@@ -2512,5 +2512,5 @@
 
         <glossentry>
-          <glossterm>loghistorycount</glossterm>
+          <glossterm><computeroutput>loghistorycount</computeroutput></glossterm>
 
           <glossdef>
@@ -2520,5 +2520,5 @@
 
         <glossentry>
-          <glossterm>autostartdbpath</glossterm>
+          <glossterm><computeroutput>autostartdbpath</computeroutput></glossterm>
 
           <glossdef>
@@ -2529,5 +2529,5 @@
 
         <glossentry>
-          <glossterm>defaultfrontend</glossterm>
+          <glossterm><computeroutput>defaultfrontend</computeroutput></glossterm>
 
           <glossdef>
@@ -2715,16 +2715,17 @@
     <para>Generally, the syntax is as follows:</para>
 
-    <screen>VBoxManage guestcontrol &lt;command&gt;</screen>
+    <screen>VBoxManage guestcontrol &lt;uuid|vmname&gt; &lt;command&gt;</screen>
 
     <para>The following subcommands are available (where
-    <computeroutput>&lt;vm&gt;</computeroutput>, in each case, can either be a
+    <computeroutput>&lt;uuid|vmname&gt;</computeroutput>, in each case, can either be a
     VM name or a VM UUID, as with the other VBoxManage commands):<itemizedlist>
         <listitem>
-          <para><computeroutput>execute</computeroutput>, which allows for
+          <para><emphasis role="bold"><computeroutput>execute</computeroutput></emphasis>,
+          which allows for
           executing a program/script (process) which already is installed and
           runnable on the guest. This command only works while a VM is up and
           running and has the following syntax:</para>
 
-          <screen>VBoxManage guestcontrol &lt;vmname&gt;|&lt;uuid&gt; exec[ute]
+          <screen>VBoxManage guestcontrol &lt;uuid|vmname&gt; exec[ute]
             --image &lt;path to program&gt; --username &lt;name&gt;
             [--passwordfile &lt;file&gt; | --password &lt;password&gt;]
@@ -2737,5 +2738,5 @@
           <para>where the parameters mean: <glosslist>
               <glossentry>
-                <glossterm>uuid|vmname</glossterm>
+                <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
 
                 <glossdef>
@@ -2745,5 +2746,5 @@
 
               <glossentry>
-                <glossterm>--image "&lt;path to program&gt;"</glossterm>
+                <glossterm><computeroutput>--image "&lt;path to program&gt;"</computeroutput></glossterm>
 
                 <glossdef>
@@ -2755,5 +2756,5 @@
 
               <glossentry>
-                <glossterm>--username &lt;name&gt;</glossterm>
+                <glossterm><computeroutput>--username &lt;name&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -2764,5 +2765,5 @@
 
               <glossentry>
-                <glossterm>--passwordfile &lt;file&gt;</glossterm>
+                <glossterm><computeroutput>--passwordfile &lt;file&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -2774,5 +2775,5 @@
 
               <glossentry>
-                <glossterm>--password &lt;password&gt;</glossterm>
+                <glossterm><computeroutput>--password &lt;password&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -2784,5 +2785,5 @@
 
               <glossentry>
-                <glossterm>--dos2unix</glossterm>
+                <glossterm><computeroutput>--dos2unix</computeroutput></glossterm>
 
                 <glossdef>
@@ -2793,6 +2794,6 @@
 
               <glossentry>
-                <glossterm>--environment
-                "&lt;NAME&gt;=&lt;VALUE&gt;"</glossterm>
+                <glossterm><computeroutput>--environment
+                    "&lt;NAME&gt;=&lt;VALUE&gt;"</computeroutput></glossterm>
 
                 <glossdef>
@@ -2817,5 +2818,5 @@
 
               <glossentry>
-                <glossterm>--timeout &lt;msec&gt;</glossterm>
+                <glossterm><computeroutput>--timeout &lt;msec&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -2829,5 +2830,5 @@
 
               <glossentry>
-                <glossterm>--unix2dos</glossterm>
+                <glossterm><computeroutput>--unix2dos</computeroutput></glossterm>
 
                 <glossdef>
@@ -2838,5 +2839,5 @@
 
               <glossentry>
-                <glossterm>--verbose</glossterm>
+                <glossterm><computeroutput>--verbose</computeroutput></glossterm>
 
                 <glossdef>
@@ -2846,5 +2847,5 @@
 
               <glossentry>
-                <glossterm>--wait-exit</glossterm>
+                <glossterm><computeroutput>--wait-exit</computeroutput></glossterm>
 
                 <glossdef>
@@ -2855,5 +2856,5 @@
 
               <glossentry>
-                <glossterm>--wait-stdout</glossterm>
+                <glossterm><computeroutput>--wait-stdout</computeroutput></glossterm>
 
                 <glossdef>
@@ -2865,5 +2866,5 @@
 
               <glossentry>
-                <glossterm>--wait-stderr</glossterm>
+                <glossterm><computeroutput>--wait-stderr</computeroutput></glossterm>
 
                 <glossdef>
@@ -2875,5 +2876,5 @@
 
               <glossentry>
-                <glossterm>[-- [&lt;argument1s&gt;] ... [&lt;argumentNs&gt;]]</glossterm>
+                <glossterm><computeroutput>[-- [&lt;argument1s&gt;] ... [&lt;argumentNs&gt;]]</computeroutput></glossterm>
 
                 <glossdef>
@@ -2923,9 +2924,10 @@
 
         <listitem>
-          <para><computeroutput>copyto</computeroutput>, which allows copying
+          <para><emphasis role="bold"><computeroutput>copyto</computeroutput></emphasis>,
+          which allows copying
           files from the host to the guest (only with installed Guest
           Additions 4.0 and later).</para>
 
-          <screen>VBoxManage guestcontrol &lt;vmname&gt;|&lt;uuid&gt; copyto|cp
+          <screen>VBoxManage guestcontrol &lt;uuid|vmname&gt; copyto|cp
             &lt;guest source&gt; &lt;host dest&gt; --username &lt;name&gt;
             [--passwordfile &lt;file&gt; | --password &lt;password&gt;]
@@ -2934,5 +2936,5 @@
           <para>where the parameters mean: <glosslist>
               <glossentry>
-                <glossterm>uuid|vmname</glossterm>
+                <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
 
                 <glossdef>
@@ -2942,5 +2944,5 @@
 
               <glossentry>
-                <glossterm>source on host</glossterm>
+                <glossterm><computeroutput>source on host</computeroutput></glossterm>
 
                 <glossdef>
@@ -2954,5 +2956,5 @@
 
               <glossentry>
-                <glossterm>destination on guest</glossterm>
+                <glossterm><computeroutput>destination on guest</computeroutput></glossterm>
 
                 <glossdef>
@@ -2963,5 +2965,5 @@
 
               <glossentry>
-                <glossterm>--username &lt;name&gt;</glossterm>
+                <glossterm><computeroutput>--username &lt;name&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -2972,5 +2974,5 @@
 
               <glossentry>
-                <glossterm>--passwordfile &lt;file&gt;</glossterm>
+                <glossterm><computeroutput>--passwordfile &lt;file&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -2982,5 +2984,5 @@
 
               <glossentry>
-                <glossterm>--password &lt;password&gt;</glossterm>
+                <glossterm><computeroutput>--password &lt;password&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -2992,5 +2994,5 @@
 
               <glossentry>
-                <glossterm>--dryrun</glossterm>
+                <glossterm><computeroutput>--dryrun</computeroutput></glossterm>
 
                 <glossdef>
@@ -3001,5 +3003,5 @@
 
               <glossentry>
-                <glossterm>--follow</glossterm>
+                <glossterm><computeroutput>--follow</computeroutput></glossterm>
 
                 <glossdef>
@@ -3010,5 +3012,5 @@
 
               <glossentry>
-                <glossterm>--recursive</glossterm>
+                <glossterm><computeroutput>--recursive</computeroutput></glossterm>
 
                 <glossdef>
@@ -3019,5 +3021,5 @@
 
               <glossentry>
-                <glossterm>--verbose</glossterm>
+                <glossterm><computeroutput>--verbose</computeroutput></glossterm>
 
                 <glossdef>
@@ -3027,5 +3029,5 @@
 
               <glossentry>
-                <glossterm>--flags &lt;flags&gt;</glossterm>
+                <glossterm><computeroutput>--flags &lt;flags&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -3038,5 +3040,6 @@
 
         <listitem>
-          <para><computeroutput>copyfrom</computeroutput>, which allows copying
+          <para><emphasis role="bold"><computeroutput>copyfrom</computeroutput></emphasis>,
+          which allows copying
           files from the guest to the host (only with installed Guest
           Additions 4.0 and later). It has the same parameters as
@@ -3045,9 +3048,10 @@
 
         <listitem>
-          <para><computeroutput>createdirectory</computeroutput>, which allows
+          <para><emphasis role="bold"><computeroutput>createdirectory</computeroutput></emphasis>,
+          which allows
           copying files from the host to the guest (only with installed Guest
           Additions 4.0 and later).</para>
 
-          <screen>VBoxManage guestcontrol &lt;vmname&gt;|&lt;uuid&gt; createdir[ectory]|mkdir|md
+          <screen>VBoxManage guestcontrol &lt;uuid|vmname&gt; createdir[ectory]|mkdir|md
             &lt;guest directory&gt;... --username &lt;name&gt;
             [--passwordfile &lt;file&gt; | --password &lt;password&gt;]
@@ -3056,5 +3060,5 @@
           <para>where the parameters mean: <glosslist>
               <glossentry>
-                <glossterm>uuid|vmname</glossterm>
+                <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
 
                 <glossdef>
@@ -3064,5 +3068,5 @@
 
               <glossentry>
-                <glossterm>directory to create on guest</glossterm>
+                <glossterm><computeroutput>directory to create on guest</computeroutput></glossterm>
 
                 <glossdef>
@@ -3078,5 +3082,5 @@
 
               <glossentry>
-                <glossterm>--username &lt;name&gt;</glossterm>
+                <glossterm><computeroutput>--username &lt;name&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -3087,5 +3091,5 @@
 
               <glossentry>
-                <glossterm>--passwordfile &lt;file&gt;</glossterm>
+                <glossterm><computeroutput>--passwordfile &lt;file&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -3097,5 +3101,5 @@
 
               <glossentry>
-                <glossterm>--password &lt;password&gt;</glossterm>
+                <glossterm><computeroutput>--password &lt;password&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -3107,5 +3111,5 @@
 
               <glossentry>
-                <glossterm>--parents</glossterm>
+                <glossterm><computeroutput>--parents</computeroutput></glossterm>
 
                 <glossdef>
@@ -3121,5 +3125,5 @@
 
               <glossentry>
-                <glossterm>--mode &lt;mode&gt;</glossterm>
+                <glossterm><computeroutput>--mode &lt;mode&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -3132,5 +3136,5 @@
 
               <glossentry>
-                <glossterm>--verbose</glossterm>
+                <glossterm><computeroutput>--verbose</computeroutput></glossterm>
 
                 <glossdef>
@@ -3142,8 +3146,121 @@
 
         <listitem>
-          <para><computeroutput>stat</computeroutput>, which displays file
+          <para><emphasis role="bold"><computeroutput>createtemporary</computeroutput></emphasis>,
+          which allows
+          copying files from the host to the guest (only with installed Guest
+          Additions 4.2 and later).</para>
+
+          <screen>VBoxManage guestcontrol &lt;uuid|vmname&gt; createtemp[orary]|mktemp
+            &lt;template&gt; --username &lt;name&gt;
+            [--passwordfile &lt;file&gt; | --password &lt;password&gt;]
+            [--directory] [--secure] [--tmpdir &lt;directory&gt;]
+            [--domain &lt;domain&gt;] [--mode &lt;mode&gt;] [--verbose]</screen>
+
+          <para>where the parameters mean: <glosslist>
+              <glossentry>
+                <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>The VM UUID or VM name. Mandatory.</para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>template</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>A file name without a path and with at least three consecutive 'X'
+                    characters or ending in 'X'
+                  </para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>--username &lt;name&gt;</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>Name of the user the copy process should run under.
+                  This user must exist on the guest OS.</para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>--passwordfile &lt;file&gt;</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>Password of the user account specified to be read from
+                  the given file. If not given, an empty password is
+                  assumed.</para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>--password &lt;password&gt;</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>Password of the user account specified with
+                  <computeroutput>--username</computeroutput>. If not given,
+                  an empty password is assumed.</para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>--directory</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>Create a temporary directory instead of a file.</para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>--secure</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>
+                    Secure creation. The file mode is fixed to
+                    <computeroutput>0755</computeroutput>. And the operation
+                    will fail if it cannot performed securely.
+                  </para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>--tmpdir &lt;directory&gt;</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>
+                    Directory where the file / directory is created. If not
+                    specified, the platform-specific temp directory is used.
+                  </para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>--mode &lt;mode&gt;</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>Sets the permission mode of the specified directory.
+                  Only octal modes (e.g.
+                  <computeroutput>0755</computeroutput>) are supported right
+                  now.</para>
+                </glossdef>
+              </glossentry>
+
+              <glossentry>
+                <glossterm><computeroutput>--verbose</computeroutput></glossterm>
+
+                <glossdef>
+                  <para>Tells VBoxManage to be more verbose.</para>
+                </glossdef>
+              </glossentry>
+            </glosslist></para>
+        </listitem>
+
+        <listitem>
+          <para><emphasis role="bold"><computeroutput>stat</computeroutput></emphasis>,
+          which displays file
           or file system status on the guest.</para>
 
-          <screen>VBoxManage guestcontrol &lt;vmname&gt;|&lt;uuid&gt; stat
+          <screen>VBoxManage guestcontrol &lt;uuid|vmname&gt; stat
             &lt;file&gt;... --username &lt;name&gt;
             [--passwordfile &lt;file&gt; | --password &lt;password&gt;]
@@ -3152,5 +3269,5 @@
           <para>where the parameters mean: <glosslist>
               <glossentry>
-                <glossterm>uuid|vmname</glossterm>
+                <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
 
                 <glossdef>
@@ -3160,5 +3277,5 @@
 
               <glossentry>
-                <glossterm>file element(s) to check on guest</glossterm>
+                <glossterm><computeroutput>file element(s) to check on guest</computeroutput></glossterm>
 
                 <glossdef>
@@ -3171,5 +3288,5 @@
 
               <glossentry>
-                <glossterm>--username &lt;name&gt;</glossterm>
+                <glossterm><computeroutput>--username &lt;name&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -3180,5 +3297,5 @@
 
               <glossentry>
-                <glossterm>--passwordfile &lt;file&gt;</glossterm>
+                <glossterm><computeroutput>--passwordfile &lt;file&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -3190,5 +3307,5 @@
 
               <glossentry>
-                <glossterm>--password &lt;password&gt;</glossterm>
+                <glossterm><computeroutput>--password &lt;password&gt;</computeroutput></glossterm>
 
                 <glossdef>
@@ -3200,5 +3317,5 @@
 
               <glossentry>
-                <glossterm>--verbose</glossterm>
+                <glossterm><computeroutput>--verbose</computeroutput></glossterm>
 
                 <glossdef>
@@ -3210,9 +3327,10 @@
 
         <listitem>
-          <para><computeroutput>updateadditions</computeroutput>, which allows
+          <para><emphasis role="bold"><computeroutput>updateadditions</computeroutput></emphasis>,
+          which allows
           for updating an already installed Guest Additions version on the
           guest (only already installed Guest Additions 4.0 and later).</para>
 
-          <screen>VBoxManage guestcontrol &lt;vmname&gt;|&lt;uuid&gt; updateadditions
+          <screen>VBoxManage guestcontrol &lt;uuid|vmname&gt; updateadditions
             [--source "&lt;guest additions .ISO file to use&gt;"] [--verbose]
             [--wait-start] [-- [&lt;argument1&gt;] ... [&lt;argumentN&gt;]]</screen>
@@ -3220,5 +3338,5 @@
           <para>where the parameters mean: <glosslist>
               <glossentry>
-                <glossterm>uuid|vmname</glossterm>
+                <glossterm><computeroutput>uuid|vmname</computeroutput></glossterm>
 
                 <glossdef>
@@ -3238,5 +3356,5 @@
 
               <glossentry>
-                <glossterm>--verbose</glossterm>
+                <glossterm><computeroutput>--verbose</computeroutput></glossterm>
 
                 <glossdef>
@@ -3246,5 +3364,5 @@
 
               <glossentry>
-                <glossterm>--wait-start</glossterm>
+                <glossterm><computeroutput>--wait-start</computeroutput></glossterm>
                 <glossdef>
                   <para>Starts the regular updating process and waits until the
@@ -3258,5 +3376,5 @@
 
               <glossentry>
-                <glossterm>[-- [&lt;argument1s&gt;] ... [&lt;argumentNs&gt;]]</glossterm>
+                <glossterm><computeroutput>[-- [&lt;argument1s&gt;] ... [&lt;argumentNs&gt;]]</computeroutput></glossterm>
 
                 <glossdef>
@@ -3461,5 +3579,5 @@
     <glosslist>
       <glossentry>
-        <glossterm>list</glossterm>
+        <glossterm><computeroutput>list</computeroutput></glossterm>
 
         <glossdef>
@@ -3471,5 +3589,5 @@
 
       <glossentry>
-        <glossterm>setup</glossterm>
+        <glossterm><computeroutput>setup</computeroutput></glossterm>
 
         <glossdef>
@@ -3484,5 +3602,5 @@
 
       <glossentry>
-        <glossterm>enable</glossterm>
+        <glossterm><computeroutput>enable</computeroutput></glossterm>
 
         <glossdef>
@@ -3496,5 +3614,5 @@
 
       <glossentry>
-        <glossterm>disable</glossterm>
+        <glossterm><computeroutput>disable</computeroutput></glossterm>
 
         <glossdef>
@@ -3508,5 +3626,5 @@
 
       <glossentry>
-        <glossterm>query</glossterm>
+        <glossterm><computeroutput>query</computeroutput></glossterm>
 
         <glossdef>
@@ -3522,5 +3640,5 @@
 
       <glossentry>
-        <glossterm>collect</glossterm>
+        <glossterm><computeroutput>collect</computeroutput></glossterm>
 
         <glossdef>