Index: trunk/include/VBox/vmm/hm_vmx.h
===================================================================
--- trunk/include/VBox/vmm/hm_vmx.h	(revision 47108)
+++ trunk/include/VBox/vmm/hm_vmx.h	(revision 47109)
@@ -589,5 +589,5 @@
 #define VMX_EXIT_INVALID            -1
 /** 0 Exception or non-maskable interrupt (NMI). */
-#define VMX_EXIT_XCPT_NMI           0
+#define VMX_EXIT_XCPT_OR_NMI        0
 /** 1 External interrupt. */
 #define VMX_EXIT_EXT_INT            1
Index: trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp	(revision 47108)
+++ trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp	(revision 47109)
@@ -271,5 +271,5 @@
 #endif
 
-HMVMX_EXIT_DECL hmR0VmxExitXcptNmi(PVMCPU pVCpu, PCPUMCTX pMixedCtx, PVMXTRANSIENT pVmxTransient);
+HMVMX_EXIT_DECL hmR0VmxExitXcptOrNmi(PVMCPU pVCpu, PCPUMCTX pMixedCtx, PVMXTRANSIENT pVmxTransient);
 HMVMX_EXIT_DECL hmR0VmxExitExtInt(PVMCPU pVCpu, PCPUMCTX pMixedCtx, PVMXTRANSIENT pVmxTransient);
 HMVMX_EXIT_DECL hmR0VmxExitTripleFault(PVMCPU pVCpu, PCPUMCTX pMixedCtx, PVMXTRANSIENT pVmxTransient);
@@ -348,5 +348,5 @@
 static const PFNVMEXITHANDLER g_apfnVMExitHandlers[VMX_EXIT_MAX + 1] =
 {
- /* 00  VMX_EXIT_XCPT_NMI                */  hmR0VmxExitXcptNmi,
+ /* 00  VMX_EXIT_XCPT_OR_NMI             */  hmR0VmxExitXcptOrNmi,
  /* 01  VMX_EXIT_EXT_INT                 */  hmR0VmxExitExtInt,
  /* 02  VMX_EXIT_TRIPLE_FAULT            */  hmR0VmxExitTripleFault,
@@ -7200,5 +7200,5 @@
         case VMX_EXIT_RDTSCP:                  rc = hmR0VmxExitRdtscp(pVCpu, pMixedCtx, pVmxTransient); break;
         case VMX_EXIT_APIC_ACCESS:             rc = hmR0VmxExitApicAccess(pVCpu, pMixedCtx, pVmxTransient); break;
-        case VMX_EXIT_XCPT_NMI:                rc = hmR0VmxExitXcptNmi(pVCpu, pMixedCtx, pVmxTransient); break;
+        case VMX_EXIT_XCPT_NMI:                rc = hmR0VmxExitXcptOrNmi(pVCpu, pMixedCtx, pVmxTransient); break;
         case VMX_EXIT_MOV_CRX:                 rc = hmR0VmxExitMovCRx(pVCpu, pMixedCtx, pVmxTransient); break;
         case VMX_EXIT_EXT_INT:                 rc = hmR0VmxExitExtInt(pVCpu, pMixedCtx, pVmxTransient); break;
@@ -7348,7 +7348,7 @@
 
 /**
- * VM-exit handler for exceptions and NMIs (VMX_EXIT_XCPT_NMI).
- */
-HMVMX_EXIT_DECL hmR0VmxExitXcptNmi(PVMCPU pVCpu, PCPUMCTX pMixedCtx, PVMXTRANSIENT pVmxTransient)
+ * VM-exit handler for exceptions or NMIs (VMX_EXIT_XCPT_OR_NMI).
+ */
+HMVMX_EXIT_DECL hmR0VmxExitXcptOrNmi(PVMCPU pVCpu, PCPUMCTX pMixedCtx, PVMXTRANSIENT pVmxTransient)
 {
     HMVMX_VALIDATE_EXIT_HANDLER_PARAMS();
Index: trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp	(revision 47108)
+++ trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp	(revision 47109)
@@ -3517,5 +3517,5 @@
     switch (exitReason)
     {
-    case VMX_EXIT_XCPT_NMI:             /* 0 Exception or non-maskable interrupt (NMI). */
+    case VMX_EXIT_XCPT_OR_NMI:          /* 0 Exception or non-maskable interrupt (NMI). */
     case VMX_EXIT_EXT_INT:              /* 1 External interrupt. */
     {
@@ -4802,5 +4802,5 @@
     switch (exitReason)
     {
-    case VMX_EXIT_XCPT_NMI:             /* 0 Exception or non-maskable interrupt (NMI). */
+    case VMX_EXIT_XCPT_OR_NMI:          /* 0 Exception or non-maskable interrupt (NMI). */
     case VMX_EXIT_EXT_INT:              /* 1 External interrupt. */
     case VMX_EXIT_EPT_VIOLATION:
Index: trunk/src/VBox/VMM/VMMR3/HM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 47108)
+++ trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 47109)
@@ -62,5 +62,5 @@
 static const char * const g_apszVTxExitReasons[MAX_EXITREASON_STAT] =
 {
-    EXIT_REASON(VMX_EXIT_XCPT_NMI           ,  0, "Exception or non-maskable interrupt (NMI)."),
+    EXIT_REASON(VMX_EXIT_XCPT_OR_NMI        ,  0, "Exception or non-maskable interrupt (NMI)."),
     EXIT_REASON(VMX_EXIT_EXT_INT            ,  1, "External interrupt."),
     EXIT_REASON(VMX_EXIT_TRIPLE_FAULT       ,  2, "Triple fault."),